//  C DLL t@CłB


#include "stdafx.h"

#include "OpenCVMatCLI.h"

using namespace System::Drawing::Imaging;
using namespace Runtime::InteropServices;

using namespace OpenCVFormLib;

// wp[֐
// String(UNICODE)ANSI(_uoCg)֕ϊ
void StringToAnsi(String^ inStr, std::string& outStr)
{
	const char* chars = (const char*)(Marshal::StringToHGlobalAnsi(inStr)).ToPointer();
	outStr = chars;
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}

// RXgN^
OpenCVMatCLI::OpenCVMatCLI()
{
	m_pOpenCVMat = new OpenCVMat();
}

// fXgN^
OpenCVMatCLI::~OpenCVMatCLI()
{
	this->!OpenCVMatCLI();
}

// t@CiCU
OpenCVMatCLI::!OpenCVMatCLI()
{
	if (m_pOpenCVMat != NULL)
	{
		delete m_pOpenCVMat;
	}
}

// 摜t@C̓ǂݍ
void OpenCVMatCLI::load(String^ path)
{
	if (m_pOpenCVMat != NULL)
	{
		// String^std::strineg
		std::string strFilename;
		StringToAnsi(path, strFilename);

		m_pOpenCVMat->load(strFilename);
	}
}

// MatBitmap֕ϊ
Bitmap^ OpenCVMatCLI::getBitmap()
{
	Bitmap^ bitmap = nullptr;

	if (m_pOpenCVMat != NULL)
	{
		int width = m_pOpenCVMat->getWidth();
		int height = m_pOpenCVMat->getHeight();
		int channels = m_pOpenCVMat->getChannels();
		int stride = m_pOpenCVMat->getStride();
		unsigned char* pData = m_pOpenCVMat->getDataPtr();

		if ((width != -1) && (height != -1) && (channels != -1) && (stride != -1) &&
			(pData != NULL))
		{
			// imreadœǂݍ܂ꂽ摜24bittJ[Ȃ̂ŁA3chɂȂ
			// Ô3chȊOnullԂ
			if (channels == 3)
			{
				bitmap = gcnew Bitmap(width, height, stride,
					PixelFormat::Format24bppRgb, IntPtr(pData));
				// []
				// L@ɂāAꕔJPEG摜ǂݍނ
				// ugpꂽp[^[Lł͂܂v
				// ƗO\ꍇ܂B
				// width, height, stride̊el͖ȂȂ̂ŁA
				// pDataɃANZXۂɖ肪oĂ̂Ǝv܂B
				// ̏ꍇ́AL2sRgAEgāAȉ̃Rg
				// AEgOĂpB

				//bitmap = gcnew Bitmap(width, height, PixelFormat::Format24bppRgb);

				//Rectangle rect = Rectangle(0, 0, bitmap->Width, bitmap->Height);
				//BitmapData^ bmpData = 
				//    bitmap->LockBits(rect, ImageLockMode::ReadWrite, bitmap->PixelFormat);
				//unsigned char* pBmp = (unsigned char*)bmpData->Scan0.ToPointer();
				//int bmpStride = bmpData->Stride;

				//for (int y = 0; y < height; y++)
				//{
				//	for (int x = 0; x < width; x++)
				//	{
				//		pBmp[y*bmpStride + x * 3 + 0] = pData[y*stride + x * 3 + 0];
				//		pBmp[y*bmpStride + x * 3 + 1] = pData[y*stride + x * 3 + 1];
				//		pBmp[y*bmpStride + x * 3 + 2] = pData[y*stride + x * 3 + 2];
				//	}
				//}

				//bitmap->UnlockBits(bmpData);
			}
		}
	}

	return bitmap;
}
