
// ShowImageMFCD2DView.cpp : CShowImageMFCD2DView NX̎
//

#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "ShowImageMFCD2D.h"
#endif

#include "ShowImageMFCD2DDoc.h"
#include "ShowImageMFCD2DView.h"

#include "Helper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CShowImageMFCD2DView

IMPLEMENT_DYNCREATE(CShowImageMFCD2DView, CScrollView)

BEGIN_MESSAGE_MAP(CShowImageMFCD2DView, CScrollView)
	ON_COMMAND(ID_FILE_OPEN, &CShowImageMFCD2DView::OnFileOpen)
//	ON_REGISTERED_MESSAGE(AFX_WM_DRAW2D, &CShowImageMFCD2DView::OnAfxWmDraw2d)
ON_REGISTERED_MESSAGE(AFX_WM_DRAW2D, &CShowImageMFCD2DView::OnAfxWmDraw2d)
ON_WM_DESTROY()
END_MESSAGE_MAP()

// CShowImageMFCD2DView RXgNV/fXgNV

CShowImageMFCD2DView::CShowImageMFCD2DView() : 
	m_pD2DBitmap(NULL)
{
	// TODO: \zR[hɒǉ܂B
	EnableD2DSupport();
}

CShowImageMFCD2DView::~CShowImageMFCD2DView()
{
}

BOOL CShowImageMFCD2DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CScrollView::PreCreateWindow(cs);
}

// CShowImageMFCD2DView `

void CShowImageMFCD2DView::OnDraw(CDC* /*pDC*/)
{
	CShowImageMFCD2DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

void CShowImageMFCD2DView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: ̃r[̃TCY̍vvZ܂B
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}


// CShowImageMFCD2DView ff

#ifdef _DEBUG
void CShowImageMFCD2DView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CShowImageMFCD2DView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CShowImageMFCD2DDoc* CShowImageMFCD2DView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CShowImageMFCD2DDoc)));
	return (CShowImageMFCD2DDoc*)m_pDocument;
}
#endif //_DEBUG


// CShowImageMFCD2DView bZ[W nh[


void CShowImageMFCD2DView::OnFileOpen()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	HRESULT hr = S_OK;

	CString filter(
		L"All Image Files|*.bmp;*.png;*.jpg;*.jpeg;*.tif|"
		L"Windows Bitmap|*.bmp|"
		L"Portable Network Graphics|*.png|"
		L"JPEG File Interchange Format|*.jpg;*.jpeg|"
		L"Tiff File|*.tif|"
		L"All Files|*.*||");
	CFileDialog openFileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, filter);

	CString cstrFileName;

	INT_PTR ret = openFileDlg.DoModal();
	if (ret == IDOK)
	{
		cstrFileName = openFileDlg.GetPathName();
		if (!cstrFileName.IsEmpty())
		{
			HRESULT hr = Load(cstrFileName);
			if (SUCCEEDED(hr))
			{
				UpdateScroll();
				//CSize sizeTotal;
				//D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
				//sizeTotal.SetSize(imageSize.width, imageSize.height);
				//SetScrollSizes(MM_TEXT, sizeTotal);
				//ScrollToPosition(CPoint(0, 0));
				// ^Cgo[
				int len = cstrFileName.GetLength();
				int pos = cstrFileName.ReverseFind(_T('\\'));
				CString cstrTitle = cstrFileName.Right(len - pos - 1) + _T(" - ImageProc");
				AfxGetMainWnd()->SetWindowText(cstrTitle);
			}
			else
			{
				MessageBox(L"摜t@Cǂݍݎs", L"G[", MB_ICONEXCLAMATION | MB_OK);
			}
		}
	}
}


afx_msg LRESULT CShowImageMFCD2DView::OnAfxWmDraw2d(WPARAM wParam, LPARAM lParam)
{
	CHwndRenderTarget* pRenderTarget = (CHwndRenderTarget*)lParam;
	ASSERT_VALID(pRenderTarget);

	if (pRenderTarget->IsValid())
	{
		D2D1_COLOR_F color = { 0.8f, 0.8f, 0.8f }; // r, g, b
		pRenderTarget->Clear(color);
		if (m_pD2DBitmap != NULL)
		{
			CPoint point = GetScrollPosition();
			D2D1_MATRIX_3X2_F matrix = D2D1::Matrix3x2F::Translation((float)-point.x, (float)-point.y);
			pRenderTarget->SetTransform(matrix);

			D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
			D2D1_RECT_F rectangle = D2D1::RectF(0.0f, 0.0f, (float)imageSize.width, (float)imageSize.height);

			ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();
			pHwndRenderTarget->DrawBitmap(m_pD2DBitmap, rectangle);
		}
	}
	return 0;
}


void CShowImageMFCD2DView::OnDestroy()
{
	CScrollView::OnDestroy();

	// TODO: ɃbZ[W nh[ R[hǉ܂B
	SafeRelease(&m_pD2DBitmap);
}

HRESULT CShowImageMFCD2DView::Load(CString path)
{
	HRESULT hr = S_OK;

	std::wstring wstrFilename((LPCTSTR)path);
	// ϊ
	std::string strFilename;
	wStrToMbStr(wstrFilename, strFilename);

	cv::Mat mat = cv::imread(strFilename);
	if (mat.data == NULL)
	{
		hr = E_FAIL;
	}
	else
	{
		//m_mat.release();
		m_mat = mat;
		hr = CreateD2DBitmapFromMat();
		InvalidateRect(NULL, TRUE);
	}

	return hr;
}

HRESULT CShowImageMFCD2DView::CreateD2DBitmapFromMat()
{
	if (m_mat.data == NULL)
	{
		return E_FAIL;
	}

	IWICImagingFactory* pIWICFactory = NULL;

	HRESULT hr = CoCreateInstance(
		CLSID_WICImagingFactory,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_PPV_ARGS(&pIWICFactory)
		);

	BYTE* data = m_mat.ptr();
	UINT stride = m_mat.step1();
	UINT width = m_mat.cols;
	UINT height = m_mat.rows;
	UINT size = stride * height;

	IWICBitmap* pWICBitmap = NULL;

	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateBitmapFromMemory(
			width,
			height,
			GUID_WICPixelFormat24bppBGR,
			stride,
			size,
			data,
			&pWICBitmap
			);
	}

	IWICFormatConverter *pConverter = NULL;
	if (SUCCEEDED(hr))
	{
		hr = pIWICFactory->CreateFormatConverter(&pConverter);
	}

	if (SUCCEEDED(hr))
	{
		hr = pConverter->Initialize(
			pWICBitmap,
			GUID_WICPixelFormat32bppBGR,    // or GUID_WICPixelFormat32bppPBGRA
			WICBitmapDitherTypeNone,
			NULL,
			0.0f,
			WICBitmapPaletteTypeMedianCut
			);
	}

	if (m_pD2DBitmap != NULL)
	{
		SafeRelease(&m_pD2DBitmap);
		m_pD2DBitmap = NULL;
	}

	if (SUCCEEDED(hr))
	{
		CHwndRenderTarget* pRenderTarget = GetRenderTarget();
		ASSERT_VALID(pRenderTarget);
		ID2D1HwndRenderTarget* pHwndRenderTarget = pRenderTarget->GetHwndRenderTarget();

		hr = pHwndRenderTarget->CreateBitmapFromWicBitmap(
			pConverter,
			NULL,
			&m_pD2DBitmap
			);
	}

	SafeRelease(&pConverter);
	SafeRelease(&pWICBitmap);
	SafeRelease(&pIWICFactory);

	// D2DBitmapɕϊMat̓[XĂOK
	// A摜sꍇ̓[Xi摜Ă܂j
	m_mat.release();

	return hr;
}

void CShowImageMFCD2DView::UpdateScroll()
{
	CSize sizeTotal;
	D2D1_SIZE_U imageSize = m_pD2DBitmap->GetPixelSize();
	sizeTotal.SetSize(imageSize.width, imageSize.height);
	SetScrollSizes(MM_TEXT, sizeTotal);
	ScrollToPosition(CPoint(0, 0));
}
