
//  C DLL t@CłB

#include "stdafx.h"

#include "OpenCVMatCLI.h"

using namespace System::Windows;
using namespace System::Windows::Media;
using namespace Runtime::InteropServices;

using namespace OpenCVWPFLib;

// wp[֐
// String(UNICODE)ANSI(_uoCg)֕ϊ
void StringToAnsi(String^ inStr, std::string& outStr)
{
	const char* chars =
		(const char*)
		(Marshal::StringToHGlobalAnsi(inStr)).ToPointer();
	outStr = chars;
	Marshal::FreeHGlobal(IntPtr((void*)chars));
}

// RXgN^
OpenCVMatCLI::OpenCVMatCLI()
{
	m_pOpenCVMat = new OpenCVMat();
}

// fXgN^
OpenCVMatCLI::~OpenCVMatCLI()
{
	this->!OpenCVMatCLI();
}

// t@CiCU
OpenCVMatCLI::!OpenCVMatCLI()
{
	if (m_pOpenCVMat != NULL)
	{
		delete m_pOpenCVMat;
	}
}

// 摜t@C̓ǂݍ
void OpenCVMatCLI::load(String^ path)
{
	if (m_pOpenCVMat != NULL)
	{
		// String^std::strineg
		std::string strFilename;
		StringToAnsi(path, strFilename);

		m_pOpenCVMat->load(strFilename);
	}
}

// MatBItmapSource֕ϊ
BitmapSource^ OpenCVMatCLI::getBitmapSource()
{
	WriteableBitmap^ writeableBitmap = nullptr;

	if (m_pOpenCVMat != NULL)
	{
		int width = m_pOpenCVMat->getWidth();
		int height = m_pOpenCVMat->getHeight();
		int channels = m_pOpenCVMat->getChannels();
		int stride = m_pOpenCVMat->getStride();
		int bufferSize = stride * height;
		unsigned char* pData = m_pOpenCVMat->getDataPtr();

		if ((width != -1) && (height != -1) &&
			(channels != -1) && (stride != -1) &&
			(pData != NULL))
		{
			// imreadœǂݍ܂ꂽ摜24bittJ[Ȃ̂ŁA
			// 3chɂȂ
			// Ô3chȊOnullԂ
			if (channels == 3)
			{
				writeableBitmap =
					gcnew WriteableBitmap(width, height, 96, 96, PixelFormats::Bgr24, nullptr);

				Int32Rect rect(0, 0, width, height);
				writeableBitmap->WritePixels(rect, IntPtr(pData), bufferSize, stride);
			}
		}
	}

	return writeableBitmap;
}
